import sys
import re

fn = sys.argv[1]

def strip_c(line):
    return line.replace(' (C) ', ' ').replace(' © ', ' ')

lines = [strip_c(c) for c in open(fn).read().split('\n')]

def strip_leading_star(line, leading):
    line = line.strip()
    if len(line) > 0 and line[0] == leading.strip():
        line = line[1:].strip()

    return line

# sublicense
# no (including the next paragraph)
# without limitation the rights
# AUTHORS OR COPYRIGHT HOLDERS
# NONINFRINGEMENT
MIT = """
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

# sub license
# without limitation on the rights
# no (including the next paragraph)
# AUTHOR(S) AND/OR THEIR SUPPLIERS
# NON-INFRINGEMENT
MIT2 = """
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
on the rights to use, copy, modify, merge, publish, distribute, sub
license, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice (including the next
paragraph) shall be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
THE AUTHOR(S) AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

# sublicense
# without limitation the rights
# (including the next paragraph)
# AUTHORS OR COPYRIGHT HOLDERS
# NONINFRINGEMENT
MIT3 = """
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice (including the next
paragraph) shall be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

# sub license
# without limitation the rights
# (including the next paragraph)
# VMWARE AND/OR ITS SUPPLIERS
# NON-INFRINGEMENT
#
# nir_vla.h uses this..
MIT4 = """
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sub license,
and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice (including the next
paragraph) shall be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
VMWARE AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

# sub license
# without limitation the rights
# (including the next paragraph)
# AUTHORS OR COPYRIGHT HOLDERS
# NON-INFRINGEMENT
#
# From lima
MIT5 = """
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sub license,
and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice (including the next
paragraph) shall be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
"""

# MIT on oneline
MITs = [MIT, MIT2, MIT3, MIT4, MIT5]

MIT_words = [m.replace('\n', ' ').replace('  ', ' ').strip() for m in MITs]

# Try to match MIT header from start of stripped
def match_mit(candidate):
    tmp = re.sub('\s+', ' ', ' '.join(candidate)).strip()
    for m in MIT_words:
        if tmp[0:len(m)] == m:
            return True
    return False

SPDX = 'SPDX-License-Identifier: MIT'

# Detect MIT lines

def doit(leading):
    stripped = [strip_leading_star(line, leading).replace('  ', ' ').replace('  ', ' ').strip() for line in lines]
    for i, line in enumerate(stripped[0:40]):
        if match_mit(stripped[i:]):
            if i > 1 and len(stripped[i - 1]) == 0:
                i = i - 1

            endj = None
            for j, line2 in enumerate(stripped[i:]):
                if line2.endswith('SOFTWARE.'):
                    endj = j
            assert(endj != None)
            rebuilt_lines = lines[0:i] + [leading + SPDX] + lines[(i + endj + 1):]
            open(fn, "w").write('\n'.join(rebuilt_lines))
            sys.exit(0)

if fn.endswith('xml'):
    if lines[1].startswith('  '):
        # bifrost XML
        doit('  ')
    else:
        # perf XML
        doit('')
else:
    # normal files
    doit('# ' if fn.endswith('build') or fn.endswith('py') else ' * ')
    doit('# ' if not (fn.endswith('build') or fn.endswith('py')) else ' * ')

# No MIT found
sys.exit(1)
